import { EditorView, basicSetup } from 'codemirror';
import { json } from '@codemirror/lang-json';

let editor: EditorView = null;

/**
 * 创建单例
 * @param el
 * @returns
 */
const createEditorInstance = (el?: HTMLDivElement) => {
  if (editor && el) {
    editor.dom.appendChild(el);
    return editor;
  } else if (editor) {
    return editor;
  }
  editor = new EditorView({
    extensions: [basicSetup, json()],
    parent: el || document.body,
  });
  return editor;
};

/**
 * 每次都创建新的实例
 * @param el
 * @returns
 */
export const createEditor = (el: HTMLDivElement) => {
  return new EditorView({
    extensions: [basicSetup, json()],
    parent: el || document.body,
  });
};

export { editor, createEditorInstance };
